Subject: TEXINFOS primary and nodist_ (was: Re: makeinfo in VPATH builds fails)

From: Stefano Lattarini <[email-masked]>
Date: Thu, 15 Sep 2011 13:34:23 +0200

Submitter: Sebastian Freundt <[email-masked]>
thanks

Reference:
 <http://debbugs.gnu.org/cgi/bugreport.cgi?bug=9506>

On Thursday 15 September 2011, Sebastian Freundt wrote:
> Stefano Lattarini <[email-masked]> writes:
>
> > The main point is that if you're distributing you `.info' files, you should
> > ensure that they are *not* rebuilt when building from a distribution tarball
> > (as that would wreak havoce with at least FreeBSD make).  OTOH, if you *want*
> > them to be rebuilt, you should *not* distribute them, and *also* add them to
> > CLEANFILES; in this case automake will build them in the buiilddir (if it
> > doesn't, than that's a bug we should fix ASAP).
> >
> > I've marked this bug closed as "wontfix", but feel free to continue the
> > discussion here if you have further doubts to clarify or ideas to contribute.
> 
> 
> Hi Stefano,
>
> I've followed your suggestions, and prefixed the TEXINFOS with `nodist_'
> and added them to CLEANFILES, however the .info file is now neither built
> nor installed (even upon make install-info).
>
Hmpf, yes, this is another limitation/incompatibility of the TEXINFOS
primary; the only ways TEXINFOS can by used are:

  # Will cause generation of foo.info, foo.pdf, etc.
  info_TEXINFOS = foo.texi
  # Will declare that these files ae required when building `foo.texi'
  foo_TEXINFOS = bar.texi baz.texi

So, when automake sees nodist_TEXINFOS, it thinks that it just lists extra
`.texi' files required by `nodist.texi' ... And it doesn't even warn that
`nodist.texi' is not really used anywhere!

There is already a bug report about this situation:
 <http://debbugs.gnu.org/cgi/bugreport.cgi?bug=7657>
but I had forgotten about it.  Thanks for reminding me!

> 
> In my case the .info files should be rebuilt and not distributed as they
> contain partially auto-generated content.
>
OK.  Maybe you might use a dist-hook to remove the `.info' files not
intended for distribution from the distdir, just before the distribution
tarball is created.  See:
 <http://www.gnu.org/software/automake/manual/html_node/The-dist-Hook.html>

> Another bug report?
Good idea.  I've already opened it (hopefully in your name, otherwise I'll
fix that later).
 
> Cheers
> Sebastian

Thanks,
  Stefano